﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using HaloMap;

namespace Gravemind
{
    public partial class TagSwapper : Form
    {
        MapForm form;
        Tag newtag = new Tag();
        int[] Index;
        
        public TagSwapper(MapForm map, int[] Index)
        {
            InitializeComponent();
            this.form = map;
            this.Index = Index;
        }

        private void TagSwapper_Load(object sender, EventArgs e)
        {
            foreach (Tag t in form.Map.Tags)
            {
                if (comboBoxEx1.Items.Contains(t.Class) == false)
                {
                    comboBoxEx1.Items.Add(t.Class);
                }
            }
            comboBoxEx1.Sorted = true; 
            comboBoxEx1.Text = form.Map.SelectedTag.Idents[Index[0]].Class;
            comboBoxEx2.Text = form.Map.SelectedTag.Idents[Index[0]].Tag.Path;
        }

        private void comboBoxEx1_SelectedIndexChanged(object sender, EventArgs e)
        {
            comboBoxEx2.Items.Clear();
            newtag.Class = comboBoxEx1.SelectedItem.ToString();
            foreach (Tag t in form.Map.Tags)
            {
                if (t.Class == newtag.Class)
                {
                    comboBoxEx2.Items.Add(t.Path);
                }
            }
            comboBoxEx2.Items.Add("Null");
            comboBoxEx2.Sorted = true;
        }

        private void buttonX1_Click(object sender, EventArgs e)
        {
            newtag.Path = comboBoxEx2.SelectedItem.ToString();
            newtag.Identifier = form.Map.FindIdent(newtag.Class, newtag.Path);
            for (int i = 0; i < Index.Length; i++)
            {
                form.Map.SelectedTag.Idents[Index[i]].Tag = newtag;
                form.Map.SelectedTag.Idents[Index[i]].Write(form.Map);
            }
            form.LoadIdents();
            MessageBox.Show("Done!");
            this.Close();
        }

        private void buttonX2_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
