﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HaloMap
{
    public class Header
    {
        #region Fields
        public string Head;
        public int HaloVersion;
        public int MapSize;
        public int IndexOffset;
        public int IndexSize;
        public int MetaTableSize;
        public int NonRawSize;
        public string BuildDate;
        public MapType MapType;
        public int SIDMetaTableOffset;
        public int SIDCount;
        public int SIDTableSize;
        public int SIDIndexOffset;
        public int SIDTableOffset;
        public string MapName;
        public string Scenario;
        public int TagCount;
        public int FileTableOffset;
        public int FileTableSize;
        public int FileTableIndexOffset;
        public int ModelRawTableStart;
        public int ModelRawTableSize;
        public int Checksum;
        public string Foot;
        #endregion

        #region Methods
        public void Read(Map map)
        {
            map.br.BaseStream.Position = 0;
            Head = new string(map.br.ReadChars(4));
            HaloVersion = map.br.ReadInt32();
            if (HaloVersion != 8)
            {
                throw new Exception("Invalid Halo Map Type!");
            }
            MapSize = map.br.ReadInt32();
            map.br.BaseStream.Position += 4;
            IndexOffset = map.br.ReadInt32();
            IndexSize = map.br.ReadInt32();
            MetaTableSize = map.br.ReadInt32();
            NonRawSize = map.br.ReadInt32();
            map.br.BaseStream.Position = 300;
            BuildDate = new string(map.br.ReadChars(32));
            MapType = (MapType)map.br.ReadInt32();
            map.br.BaseStream.Position = 364;
            SIDMetaTableOffset = map.br.ReadInt32();
            SIDCount = map.br.ReadInt32();
            SIDTableSize = map.br.ReadInt32();
            SIDIndexOffset = map.br.ReadInt32();
            SIDTableOffset = map.br.ReadInt32();
            map.br.BaseStream.Position = 420;
            MapName = new string(map.br.ReadChars(35));
            map.br.BaseStream.Position += 1;
            Scenario = new string(map.br.ReadChars(80));
            map.br.BaseStream.Position = 716;
            TagCount = map.br.ReadInt32();
            FileTableOffset = map.br.ReadInt32();
            FileTableSize = map.br.ReadInt32();
            FileTableIndexOffset = map.br.ReadInt32();
            map.br.BaseStream.Position = 744;
            ModelRawTableStart = map.br.ReadInt32();
            ModelRawTableSize = map.br.ReadInt32(); 
            Checksum = map.br.ReadInt32();
            map.br.BaseStream.Position = 2044;
            Foot = new string(map.br.ReadChars(4));
        }
        #endregion
    }
}
