﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace HaloMap
{
    public partial class String : UserControl
    {
        public string Description;
        public int Offset;
        public string Value;
        public StringType t;

        public String(string Description, int Offset, string Value, StringType t)
        {
            InitializeComponent();
            this.Description = Description;
            this.Offset = Offset;
            this.Value = Value;
            this.t = t;
        }

        private void Strings_Load(object sender, EventArgs e)
        {
            label1.Text = Description;
            textBox1.Text = Value;
            switch (t)
            {
                case StringType.String32:
                    {
                        textBox1.MaxLength = 32;
                        break;
                    }
                case StringType.String64:
                    {
                        textBox1.MaxLength = 64;
                        break;
                    }
                case StringType.Unicode64:
                    {
                        textBox1.MaxLength = 64;
                        break;
                    }
                case StringType.Unicode256:
                    {
                        textBox1.MaxLength = 256;
                        break;
                    }
            }
        }

        public void Update(string Val)
        {
            textBox1.Text = Val;
        }

        public string Save()
        {
            Value = textBox1.Text;
            return Value;
        }

        public void Poke(ProcessStream p, int Translation)
        {
            if (t == StringType.String32)
            {
                Value = p.ReadString(Offset - Translation, 32);
            }
            else if (t == StringType.String64)
            {
                Value = p.ReadString(Offset - Translation, 64);
            }
            textBox1.Text = Value;
        }
    }
}
